package eu.mhsl.minecraft.pixelblocks.pixelblock;

import org.bukkit.Location;
import org.bukkit.block.data.BlockData;
import org.bukkit.entity.BlockDisplay;
import org.bukkit.entity.EntityType;
import org.bukkit.util.Transformation;

public class Pixel {
    Location relativeLocation;
    BlockData blockData;
    double scale;

    public Pixel(Location relativeLocation, BlockData blockData, double scale) {
        this.relativeLocation = new Location(
                relativeLocation.getWorld(),
                relativeLocation.x(),
                relativeLocation.y(),
                relativeLocation.z()
        );
        this.blockData = blockData;
        this.scale = scale;
    }

    public void spawn(Location spawnBlockLocation) {
        double positionX = spawnBlockLocation.x()+relativeLocation.x()*scale;
        double positionY = spawnBlockLocation.y()+relativeLocation.y()*scale;
        double positionZ = spawnBlockLocation.z()+relativeLocation.z()*scale;

        Location spawnLocation = new Location(spawnBlockLocation.getWorld(), positionX, positionY, positionZ);

        BlockDisplay bd;
        bd = (BlockDisplay) spawnLocation.getWorld().spawnEntity(
            spawnLocation,
            EntityType.BLOCK_DISPLAY
        );

        bd.setBlock(blockData);

        Transformation transform = bd.getTransformation();
        transform.getScale().set(scale);
        bd.setTransformation(transform);

        System.out.println(spawnLocation.x());
        System.out.println(spawnLocation.y());
        System.out.println(spawnLocation.z());
    }
}
