package eu.mhsl.minecraft.pixelblocks.pixelblock;

import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.block.data.BlockData;

import java.util.ArrayList;

public class PixelBlock {
    double pixelsPerBlock;
    ArrayList<Pixel> pixels = new ArrayList<>();

    public PixelBlock(Location originLocation, double pixelsPerBlock) {
        this.pixelsPerBlock = pixelsPerBlock;

        for (int x = 0; x < pixelsPerBlock; x++) {
            for (int y = 0; y < pixelsPerBlock; y++) {
                for (int z = 0; z < pixelsPerBlock; z++) {
                    Location relativeLocation = new Location(originLocation.getWorld(), x, y, z);
                    Location blockLocation = originLocation.toBlockLocation().clone().add(relativeLocation);
                    BlockData block = blockLocation.getBlock().getBlockData();

                    if(block.getMaterial() != Material.AIR) {
                        Pixel newPixel = new Pixel(relativeLocation, block, (1/pixelsPerBlock));
                        pixels.add(newPixel);
                    }
                }
            }
        }

    }

    public void place(Location placeLocation) {
        placeLocation = placeLocation.toBlockLocation();
        for(Pixel pixel : pixels) {
            pixel.spawn(placeLocation);
        }
    }
}
